/*****************************************************************************
 * Author:   Valient Gough <vgough@pobox.com>
 *
 *****************************************************************************
 * Copyright (c) 2003, Valient Gough
 *
 * This library is free software; you can distribute it and/or modify it under
 * the terms of the GNU General Public License (GPL), as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GPL in the file COPYING for more
 * details.
 *
 */

#ifndef _FileInfo_incl_
#define _FileInfo_incl_

#include "LinkedOwner.h"
#include <string>

class Cypher;

class FileInfo : public rel::LinkedOwner
{
public:
    FileInfo( const char *fileName, Cypher *cypher, void *key );
    FileInfo( const FileInfo &src );
    ~FileInfo();

    FileInfo & operator = (const FileInfo &src);

    static std::string encodeName(const char *plaintextName, Cypher *cypher,
	                      void *key);
    static std::string decodeName(const char *cypherName, Cypher *cypher,
	                      void *key);

    // return plaintext name
    std::string name() const;
    // return cypher name
    std::string cypherName() const;

private:
    struct Data
    {
	std::string name;
	std::string cypherName;
    } *data;
};


#endif

