/*****************************************************************************
 * Author:   Valient Gough <vgough@pobox.com>
 *
 *****************************************************************************
 * Copyright (c) 2003, Valient Gough
 *
 * This library is free software; you can distribute it and/or modify it under
 * the terms of the GNU General Public License (LGPL), as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GPL in the file COPYING for more
 * details.
 *
 */

#ifndef _MemoryPool_incl_
#define _MemoryPool_incl_


/*
    Memory Pool for fixed sized objects.
*/
class MemoryPool
{
public:
    MemoryPool( int elementSize );
    ~MemoryPool();

    void *allocate();
    void release(void *el);

    // free all blocks that are not in use..
    void freeAvailable();

private:
    struct BlockList *available;
    int elSize;
    int offset;
    int numBlocks;
};

#endif

